<?php
/* ex: set tabstop=4 expandtab shiftwidth=4 softtabstop=4: */
/*
Acidfree image Albums for Drupal
Copyright (C) 2005 Vernon Mauery

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA
*/

/**
 * @file
 * The is the class implementation of the image.  All the acidfree elements
 * must be defined in this same manner, which makes creating a new class
 * relatively simple -- copy one of the existing classes and modify the 
 * relevant functions.
 */

//require_once('image_manip.inc');

function class_image_register() {
    $class = new stdClass();
    if (!module_exists('image')) {
        return $class;
    }
    $class->class = 'image';
    $class->max_size = 2*(1 << 20);
    /* i.e. reports image/pjpeg as mime type for jpegs.  grrr. */
    $class->mime_ext = Array('image/jpeg'=>'jpg', 'image/pjpeg'=>'jpg', 'image/png'=>'png', 'image/gif' => 'gif');
    $class->form_alter = '_class_image_form_alter';
    $class->nodeapi = '_class_image_nodeapi';
    $class->access = 'create images';
    $class->add_form = '_class_image_add';
    $class->edit_form = '_class_image_edit';
    return $class;
}

/*
function _class_image_create(&$node, &$file) {
    global $acidfree_types;
    $ext = $acidfree_types['image']->mime_ext[$file->filemime];
    $images = (variable_get('acidfree_large_dim', -1) == 0) ?
        Array('small', 'thumb'):
        Array('large', 'small', 'thumb');
    foreach ($images as $size) {
      $node->$size = acidfree_add_file($node, $file->filepath, "{$node->nid}_{$size}.{$ext}", $file->filemime, false);
    }
    if ($file->source != 'acidfree_local_filesystem') {
        file_delete($file->filepath);
    }
    _class_image_resize($node);
}

function _class_image_resize(&$node) {
    $largefile = _acidfree_get_large_path($node, true);
    $smallfile = _acidfree_get_small_path($node, true);
    $thumbfile = _acidfree_get_thumb_path($node, true);
    if (($size = variable_get('acidfree_large_dim', -1)) > 0 && $largefile) {
        $info = getimagesize($largefile);
        // give them a fudge factor for megapixel size -- up to .5 M pixels bigger
        if ($info[0] * $info[1] > ($size + 500000)) {
            $size = sqrt($size * ($info[0]/$info[1]));
            acidfree_resize_image($largefile, $largefile, $size);
        }
    } else if ($size == 0 && $largefile) {
        module_invoke('filemanager', 'delete', $node->large);
        db_query("UPDATE {acidfree} SET large='' WHERE aid={$node->nid}");
        $node->large = '';
    }
    $size = variable_get('acidfree_small_dim', IMAGE_SMALL_SIZE);
    if (is_file($smallfile)) {
        $info = getimagesize($smallfile);
    }
    if (max($info[0], $info[1]) != $size) {
        $source = ($largefile ? $largefile : $smallfile);
        acidfree_resize_image($source, $smallfile, $size);
    }
    $size = variable_get('acidfree_thumb_dim', IMAGE_THUMB_SIZE);
    if (is_file($thumbfile))
        $info = getimagesize($thumbfile);
    if (max($info[0], $info[1]) != $size) {
        acidfree_resize_image($smallfile, $thumbfile, $size);
    }
    return true;
}

function _class_image_form($op, &$node) {
    $form = array();
    switch ($op) {
    case 'new':
        break;
    case 'preview':
        $form['thumb'] = array(
                '#type' => 'hidden',
                '#value' => is_object($node->thumb)?$node->thumb->fid:$node->thumb,
            );
        break;
    case 'update':
        $form['thumb'] = array(
                '#type' => 'hidden',
                '#value' => is_object($node->thumb)?$node->thumb->fid:$node->thumb,
            );
        $options = Array(
                '270' => t('Counterclockwise'),
                '0' => t('No rotation'),
                '90' => t('Clockwise'),
                'auto'=>t('Use exif orientation tag'),
            );
        $form['rotate'] = array(
                '#type' => 'select',
                '#title' => t('Rotate image'),
                '#default_value' => '0',
                '#options' => $options,
                '#acidfree_form' => true,
            );
        break;
    }
    return $form;
}

function _class_image_destroy(&$node) {
}

function theme_acidfree_print_full_image(&$node) {
    if (!$node->small)
        return '';
    $output .= acidfree_pager_creator($node);

    $output .= "<div class='acidfree-full'>";
    $largeurl = _acidfree_get_large_url($node);
    if (!$largeurl) {
        $output .= theme('image', _acidfree_get_small_url($node),
                $node->title, $node->title, NULL, false);
    } else {
        $output .= "<a href='"._acidfree_get_large_url($node)."'>".
            theme('image', _acidfree_get_small_url($node),
                    $node->title, $node->title, NULL, false).
            "</a>";
    }
    $output .= "</div><div class='acidfree-body'>{$node->body}</div>";
    if (variable_get('acidfree_show_exif_data', false)) {
        $output .= theme('acidfree_exif_data', $node);
    }

    return $output;
}

function theme_acidfree_exif_data(&$node) {
    $output = '<div id="acidfree-exif-data"><h3>'.t('EXIF data:').'</h3>';
    $largefile = _acidfree_get_large_path($node);
    if ($largefile) {
        $exif = exif_read_data($largefile, 0, true);
        foreach ($exif as $key => $section) {
            foreach ($section as $name => $val) {
                $output .= "$key.$name: $val<br />\n";
            }
        }
    } else {
        $output .= t('no exif data');
    }
    $output .= '</div>';
    return $output;
}
*/

function _class_image_add() {
  $node = (object)array('type'=>'image');
  return drupal_get_form('image_node_form', $node);
}

function theme_acidfree_print_thumb_image(&$node, $parent=null) {
    if (count($node->parent) > 1 && $parent)
        $p = "pid={$parent->nid}";

    $image = l(theme('image', _acidfree_get_thumb_url($node),
                $node->title, $node->title, array('class'=>'acidfree'), false),
              "node/{$node->nid}", array(), $p, NULL, true, true);
    $size = variable_get('acidfree_thumb_dim', IMAGE_THUMB_SIZE) + 40;
    $cell .= "<div class='fullslide' style='width: {$size}px;'>\n";
    $size -= 20;
    $cell .= "<div class='outer' style='width: {$size}px; height: {$size}px;'>\n";
    // XXX: this empty span is to make IE render vertical alignment correctly
    $cell .= "<span></span>\n";
    $cell .= "$image\n";
    $cell .= "</div>\n";
    $cell .= "<div>{$node->title}</div>\n";
    $cell .= "</div>\n";
    return $cell;
}

function _class_image_rotate(&$node) {
    if ($node->rotate != 0) {
        _image_remove($node);
        $large_path = file_create_path($node->images['_original']);
        acidfree_rotate_image($large_path, $node->rotate);
        $filesize = filesize($large_path);
        db_query("UPDATE {files} SET filesize=%d WHERE filename='%s' AND nid=%d",
            $filesize, '_original', $node->nid);
        _image_build_derivatives($node);
    }
}

function _class_image_form_alter($form_id, &$form) {
  //drupal_set_message("form_alter: $form_id (modified)");

  if (($arg = _path_match('node', 'add', 'acidfree', 'image', '%d'))) {
      $acidfree_vid = acidfree_get_root();
      $form['taxonomy'][$acidfree_vid]['#default_value'] = $arg;
  }
  $js_attrs = array('onchange' => 'set_title(this.value);');
  $form['image']['#attributes'] = is_array($form['image']['#attributes']) ?
      array_merge($js_attrs, $form['image']['#attributes']) : $js_attrs;
  $form['body']['#rows'] = 5;
  $rotate_options = Array(
          '270' => t('Counterclockwise'),
          '0' => t('No rotation'),
          '90' => t('Clockwise'),
          'auto'=>t('Use exif orientation tag'),
      );
  $form['rotate'] = array(
          '#type' => 'select',
          '#title' => t('Rotate image'),
          '#default_value' => '0',
          '#options' => $rotate_options,
          '#acidfree_form' => true,
      );
  if (($arg = _path_match('album', '%d', 'contents'))) {
      unset($form['image']);
      unset($form['format']);
  }
}
?>
